ros-melodic-hrpsys-ros-bridge (1.4.3-1stretch) stretch; urgency=high

  * Adapt README for melodic & fix style of README & fix to run on melodic (#1090 <https://github.com/start-jsk/rtmros_common/issues/1090>)
    
      * [hrpsys_ros_bridge] Prevent collision_state.py from dying on melodic
        ModelLoader_idl should be accessed from hrpsys module as with https://github.com/fkanehiro/hrpsys-base/blob/315.15.0/python/hrpsys_config.py#L8 and https://github.com/fkanehiro/hrpsys-base/blob/315.15.0/python/hrpsys_config.py#L809.
        See https://github.com/fkanehiro/hrpsys-base/commit/2dca76137c20856fcee634f5571059bebf7d3094 and https://github.com/fkanehiro/hrpsys-base/commit/a60a34483c5b6cdd02961257b6b7c7410443fc17.
        Related to https://github.com/fkanehiro/hrpsys-base/issues/145?
    
  * use setJointAnglesOfGroup() and playPattern(), use clearJointAngles() with test (#1071 <https://github.com/start-jsk/rtmros_common/issues/1071>)
    
      * Fix swapping of clear and clearJointAngles
      * Add comments to clarify when stopping motion is executed
      * Tell getting new goal from cancel
      * setJointANglesSequenceOfGroup has bugs as of 315.15.0, use old API intead
        see https://github.com/fkanehiro/hrpsys-base/pull/1237
      * add more debug info for #765 <https://github.com/start-jsk/rtmros_common/issues/765>
      * use setJointAnglesOfGroup() and playPattern(), use clearJointAngles()
      * add code to get hrpsys rtc version, thakns to @n-ando
      * Add two points trajectory to test of joint trajectory action cancel
      * Add comment on two points trajectory to samplerobot test of joint trajectory action goal overwrite
      * Add two points trajectory to PA10 test of joint trajectory action goal overwrite
      * Add test for joint trajectory action cancel overwrite with samplerobot
      * Add test for joint trajectory action goal overwrite with PA10
      * Add test for joint trajectory action cancel with PA10
    
  * [HrpsysSeqStateROSBridge] output joint_state/velocity (#1069 <https://github.com/start-jsk/rtmros_common/issues/1069>)
    
      * [hrpsys_ros_bridge.launch] add comment to USE_VELOCITY_OUTPUT
      * [hrpsys_ros_bridge] Add test of joint_states/velocity
    
  * [rtm-ros-robot-interface.l] fix bug of :motor-extra-data (#1066 <https://github.com/start-jsk/rtmros_common/issues/1066>)
    
      * [hrpsys_ros_bridge] Add test of :motor-extra-data without ros bridge
      * [hrpsys_ros_bridge] Rename :motor-extra-data test as *.launch to be excluded from catkin_install_run_tests
        See https://github.com/start-jsk/rtmros_common/pull/1083#issuecomment-565054164 and https://github.com/start-jsk/rtmros_common/commit/6a881595b6aae3f40d572201bad6bf1a4b5950a
    
  * [rtm-ros-robot-interface.l] add method :set-ref-force-moment to rtm-ros-robot-interface class (#1045 <https://github.com/start-jsk/rtmros_common/issues/1045>)
    
      * add method :set-ref-force-moment to rtm-ros-robot-interface class
      * [hrpsys_ros_bridge] Add test of :set-ref-force-moment
    
  * Remove all ros::object slots in def-set-get-param-method (#1060 <https://github.com/start-jsk/rtmros_common/issues/1060>)
  * Set time_from_start to feedback of joint trajectory action with tests (#1073 <https://github.com/start-jsk/rtmros_common/issues/1073>)
    
      * prev_traj_tm -> traj_start_tm
      * Stop feedback when trajectory is completed
      * Set time_from_start to feedback of joint trajectory action
      * Add test of feedback from joint trajectory action with samplerobot
      * Add test of feedback from joint trajectory action with PA10
    
  * Re-enable & fix euslisp test on travis (#1085 <https://github.com/start-jsk/rtmros_common/issues/1085>)
    
      * [hrpsys_ros_bridge] fix bug in samplerobot-sequence-player.l
      * To speed up travis jobs having euslisp tests, stop other tests
    
  * Try to run multiple hrpsys simulation environments (#1054 <https://github.com/start-jsk/rtmros_common/issues/1054>)
    
      * add manager port arg in default launch templates
      * re-add omniorb_args for backward compatibility
      * change to use omniorb_args -> openrtm_args
      * support any RTCManager port num
      * update ros bridge launch files
    
  * [collision_state.py] fix argument of rospy.loginfo ( #1055 <https://github.com/start-jsk/rtmros_common/issues/1055>)
  * fix def-set-get-param-method in rtm-ros-robot-interface.l (#1053 <https://github.com/start-jsk/rtmros_common/issues/1053>)
    
      * fix def-set-get-param-method in rtm-ros-robot-interface.l
      * add forgotten argument of string= in the last commit
    
  * [hrpsys_ros_brdge] fix time-limit for test (#1057 <https://github.com/start-jsk/rtmros_common/issues/1057>)
  * Fix less than one sec (#1042 <https://github.com/start-jsk/rtmros_common/issues/1042>)
    
      * [hrpsys_ros_bridge] change abs to std::abs for trajectory_action  when it received trajectory less than 1.0 sec
      * [hrpsys_ros_bridge] add test for trajectory_action when it received trajectory less than 1.0 sec
    
  * fix typo in stop-rfu-no-wait (#1044 <https://github.com/start-jsk/rtmros_common/issues/1044>)
  * use 2899/2898 for corbaport, since omniorb-nameserver forcestarted nameserver as default port 2809 when they're first installed (#1043 <https://github.com/start-jsk/rtmros_common/issues/1043>)
  * Update GaitGenerator/ReferenceForceUpdater methods (#1040 <https://github.com/start-jsk/rtmros_common/issues/1040>)
    
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add method to configure toe heel phase ration automatically in GaitGeneratorParam.
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Update method for new ReferenceForceUpdater functionalities (https://github.com/fkanehiro/hrpsys-base/pull/1239).
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add method to print RTCs' parameters in more readable style using *print-object*.
    
  * Add method to print RTCs' parameters in more readable style using *print-object*. (#1039 <https://github.com/start-jsk/rtmros_common/issues/1039>)
  * Contributors: Guilherme Affonso, Kei Okada, Naoki Hiraoka, Shintaro Komatsu, Shun Hasegawa, Shunichi Nozawa, Yohei Kakiuchi, Yasuhiro Ishiguro

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 19 Apr 2020 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.4.2-1stretch) stretch; urgency=high

  * add test to check #1036 <https://github.com/start-jsk/rtmros_common/issues/1036> situation (#1038 <https://github.com/start-jsk/rtmros_common/issues/1038>)
  * duration == 0.0 results unexpected behavior, so force set 0.001 when duration == 0 s set (#1037 <https://github.com/start-jsk/rtmros_common/issues/1037> )
  * Contributors: Kei Okada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 21 Dec 2017 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.4.1-1stretch) stretch; urgency=high

  * Update of sensor_ros_bridge_connect.py
    * Connect ReferenceForceUpdater's ref_force (#1033 <https://github.com/start-jsk/rtmros_common/pull/1033>)[hrpsys_ros_bridge/scripts/sensor_ros_bridge_connect.py] connect reference force port to ReferenceForceUpdater or EmergencyStopper if exists.
    
      * Add wait for rmfo and vs (#1029 <https://github.com/start-jsk/rtmros_common/pull/1029>)
        * [hrpsys_ros_bridge, sensor_ros_bridge_connect.py] add wait for initalizinig all components
    
  * HrpsysSeqStateROSBridge (#1027 <https://github.com/start-jsk/rtmros_common/pull/1027>)
    * [HrpsysSeqStateROSBridge] fix for using virtual force sensor
  * Update rtm-ros-robot-interface.l (#1030 <https://github.com/start-jsk/rtmros_common/pull/1030>)
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add documentation string for new arguments (set-ref-force-linear-p, return-value-mode)
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add argument to set linear interpolation during increasing force
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Enable to set return value mode
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Enable to get fric coefficient wrench add update print messages
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Update otd checking loop for moment. Exit from do-until-key loop immediately when otd detection. Fix valiables for set ref force
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Use euslisp symbol as detector total wrench parameter
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Enable to access detector total wrench as euslisp symbol.
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Update otd checking loop. Exit from do-until-key loop immediately when otd detection.
  * Contributors: MasakiMurooka, Shunichi Nozawa, YoheiKakiuchi

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 24 Oct 2017 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.4.0-1stretch) stretch; urgency=high

  * display error message when body->sensor(j, i) is null (#1014 <https://github.com/start-jsk/rtmros_common/issues/1014>)
  * sensor_ros_bridge_connect.py : add more debug message (#1015 <https://github.com/start-jsk/rtmros_common/issues/1015>)
  * Update AutoBalancer and ReferenceForceUpdater euslisp method symbols (#1026 <https://github.com/start-jsk/rtmros_common/issues/1026>)
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Supprot :FootOriginExtMoment for RFU methods.
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Support UseForceMode setting as euslisp symbol in :set-auto-balancer-param.
  * fix code to run both Indido and Kinetic (#1025 <https://github.com/start-jsk/rtmros_common/issues/1025>)
    * /test/test-samplerobot-hcf.launch: increase time-limit to 600
    * test/{test-samplerobot.py,test-pa10.py} support both pr2_controllers_msgs and controllr_msgs
    * src/hrpsys_ros_bridge/hrpsys_dashboard.py: fix for qt5
    * add USE_PR2_CONTROLLERS_MSGS definition
    * CMakeLists.txt : we do not use pr2_msgs on build time
    * CMakeLists.txt : remove code to download wet pr2_controllers_msgs for groovy
  * Support stride parameter with different length (#1022 <https://github.com/start-jsk/rtmros_common/issues/1022>)
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Support stride_parameter of different length
    * [hrpsys_ros_bridge/test/hrpsys-samples/samplerobot-auto-balancer.l] Add test to check stride parameter 4 and 6
  * [HrpsysSeqStateROSBridge] fix stamp of joint_state. add stamp after reading m_rsangle (#1019 <https://github.com/start-jsk/rtmros_common/issues/1019>)
    * [HrpsysSeqStateROSBridge] fix stamp of joint_state. add stamp after reading m_rsangle
  * [HrpsysSeqStateROSBridge] remove subtraction magic number (#1013 <https://github.com/start-jsk/rtmros_common/issues/1013>)
    * [HrpsysSeqStateROSBridge] remove subtraction magic number
  * Support argumen t for setting duration of calibration. For :remove-xx methods, 8.0 by default[s]. For :reset-xx methods, 0.1[s] by default for compatibility (#1011 <https://github.com/start-jsk/rtmros_common/issues/1011>)
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Support argument for setting duration of calibration. For :remove-xx methods, 8.0 by default[s]. For :reset-xx methods, 0.1[s] by default for compatibility
  * Add new methods for :remove-force-sensor-offset using RMFO (#1010 <https://github.com/start-jsk/rtmros_common/issues/1010>)
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add new methods for :remove-force-sensor-offset using RMFO. Add warning message for deprecated remove-force methods.
  * Update euslisp hrpsysbase samples (#1009 <https://github.com/start-jsk/rtmros_common/issues/1009>)
    * [hrpsys_ros_bridge/test/hrpsys-samples] Add README for Euslisp hrpsys example basically copied from ros wiki (http://wiki.ros.org/rtmros_common/Tutorials/WorkingWithEusLisp)
    * [hrpsys_ros_bridge/test/hrpsys-samples/samplerobot-carry-object.l] Update carry demo euslisp sample.
    * [hrpsys_ros_bridge/test/hrpsys-samples/samplerobot-stabilizer.l] Update stabilizer euslisp sample according to hrpsys-base stabilizer sample update.
  * Fix bug of sample4leg robot end-coords setting for arms. (#1008 <https://github.com/start-jsk/rtmros_common/issues/1008>)
    * [hrpsys_ros_bridge/models/sample4legrobot.yaml] Fix bug of sample4legrobot end-coords setting for arms.
  * Update project generator and refforce (#1007 <https://github.com/start-jsk/rtmros_common/issues/1007>)
    * [hrpsys_ros_bridge/euslisp] Update README for openhrp-project-generator
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Fix orientation for openhrp-project-generator
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Update for object turnaround detection to use initial ref forces
    * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Update dump function for openhrp project generator. Use openhrp-project-generator in openhrp3 package instead of _gen_project.launch
  * Add forgotten update for robot.launch (https://github.com/start-jsk/rtmros_common/pull/1004) (#1005 <https://github.com/start-jsk/rtmros_common/issues/1005>)
    * [hrpsys_ros_bridge/scripts/default_robot.launch.in] Add forgotten update in https://github.com/start-jsk/rtmros_common/pull/1004. Add USE_XXX of under-development RTCs for robot.launch such as samplerobot.launch to pass arguments to robot_ros_bridge.launch
  * set USE_UNSTABLE_RTC as not all unstable rtc defiend in hrpsys_config.py, just for basic walking test, other latest development rtc is passed by arg (#1004 <https://github.com/start-jsk/rtmros_common/issues/1004>)
    * set USE_UNSTABLE_RTC as not getUnstableRTC defined in hrpsys_config.py, it is for a basic walking test, other latest development rtc is passed by arg from test_samplerobot_euslisp_unittests.launch
    * [hrpsys_ros_bridge/launch/hrpsys_ros_bridge.launch,hrpsys_ros_bridge/scripts/default_robot_ros_bridge.launch.in,hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l,hrpsys_tools/launch/hrpsys.launch] Update for ObjectTurnaroundDetector RTC. add USE_REFERENCEFORCEUDPATER and USE_OBJECTCONTACTTURNAROUNDDETECTOR.
  * Contributors: Kei Okada, Shunichi Nozawa, Yohei Kakiuchi

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 08 Aug 2017 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.3.3-1stretch) stretch; urgency=high

  * HrpsysSeqStateROSBridge.cpp
    * HrpsysSeqStateROSBridge occurs error if number of force sensor is different with size of contact states. fix number of force sensor (#982 <https://github.com/start-jsk/rtmros_common/issues/982>)
    * Revert "[HrpsysSeqStateROSBridge] fix number of force sensor" #984 <https://github.com/start-jsk/rtmros_common/issues/984>
    * Separate offset-removed force sensor data ports from rsforce, which is actual and non-offset-removed data port. Currently rsforce ports -> rsforce ports + offforce ports. (#964 <https://github.com/start-jsk/rtmros_common/issues/964>)
    * Fixed mistake of sensor_link_name, when robot has only virturl force sonsors (#945 <https://github.com/start-jsk/rtmros_common/issues/945>)
  * HrpsysJointTrajectoryBridge.cpp
    * publish feedback for joint_trajectory_actions (#966 <https://github.com/start-jsk/rtmros_common/issues/966>)
  * hrpsys_ros_bridge/launch/hrpsys_ros_bridge.launch
    * Add argument to change buffer length of rtmlaunch connection. Set 8 by default (default setting in openrtm). (#980 <https://github.com/start-jsk/rtmros_common/issues/980>)
    * fix model filename. Enable cache in ModelLoader, filename should be same as in .conf file. (#978 <https://github.com/start-jsk/rtmros_common/issues/978>)
  * euslisp
    * [rtm-ros-robot-interface.l] refactor torque-controller interface (#994 <https://github.com/start-jsk/rtmros_common/issues/994>)
    * Update sequencefull unit system and arguments (#988 <https://github.com/start-jsk/rtmros_common/issues/988>)changed arguments of angle-vector-sequence-full see #985
    
    [hrpsys-samples/samplerobot-sequence-player.l] Add test for angle-vector-sequence-full (check validity)
    
    [rtm-ros-robot-interface.l] Use root-coords and zmp in the abs frame and convert them inside the :angle-vector-sequence-full
    
    [rtm-ros-robot-interface.l] Introduce fsensor length for wrench and optionals
    
    [rtm-ros-robot-interface.l] Use [mm] and [deg/s] instead of [m] and [rad/s] for vel, pos, and zmp.
    
    [rtm-ros-robot-interface.l] Use [deg] instead of [rad] for jpos argument and remove jvs arg.
    
    [rtm-ros-robot-interface.l] Use tm as [ms], previously [s].
    
      * [tm-ros-robot-interface.l] Update :reset-force-moment-offset to use :off force/moment vector (#983 <https://github.com/start-jsk/rtmros_common/issues/983>)
      * [tm-ros-robot-interface.l] Added a missing keyword in def-set-get-method for TorqueControllerService. (#972 <https://github.com/start-jsk/rtmros_common/issues/972>)
      * [tm-ros-robot-interface.l] Add euslisp interface for torque controller (#965 <https://github.com/start-jsk/rtmros_common/issues/965>)
      * [datalogger-log-parser.l] Modify unit of cogvel [m] -> [mm] for euslisp (#960 <https://github.com/start-jsk/rtmros_common/issues/960>)
      * [rtm-ros-robot-interface.l] Add get-go-pos-footsteps-sequence in rtm-ros-robot-interface.l and add test (#965 <https://github.com/start-jsk/rtmros_common/issues/965>)
      * [rtm-ros-robot-interface.l] Update frame of wrench. Previously, wrench frame is mismatch with documentation string. Previous : local -> new : world. (#963 <https://github.com/start-jsk/rtmros_common/issues/963>)
      * [rtm-ros-robot-interface.l] Add eefm force moment distribution weight parameter. (#958 <https://github.com/start-jsk/rtmros_common/issues/958>)
      * [rtm-ros-robot-interface.l] add Eus interface of SequencePlayserService_setJointAnglesSequenceFull and add test in test/hrpsys-samples/samplerobot-sequence-player.l (#954 <https://github.com/start-jsk/rtmros_common/issues/954>)
      * [datalogger-log-parser.l] Add sh reference force and support both rpy and 3x3 matrix for WAIST log(#956 <https://github.com/start-jsk/rtmros_common/issues/956>)
      * [rtm-ros-robot-interface.l] update rfu interface for idl changed in https://github.com/fkanehiro/hrpsys-base/pull/1005 (#952 <https://github.com/start-jsk/rtmros_common/issues/952>)
      * [datalogger-log-parser.l] Use joint-list length for datalogger joint angle conversion. (#953 <https://github.com/start-jsk/rtmros_common/issues/953>)
        * Add simulation actual root coords reading and check for existance of RobotHardware0_servoState in datalogger. Fix setting of simulators' data parser names.
        *  Use joint-list length for datalogger joint angle conversion.
      * [rtm-ros-robot-interface.l] make directory for log files (#951 <https://github.com/start-jsk/rtmros_common/issues/951>)
    
  * [scripts/default_robot_ros_bridge.launch.in] Add nameserver argument for ros_bridge.launch (#950 <https://github.com/start-jsk/rtmros_common/issues/950>)
  * [test/hrpsys-samples/samplerobot-stabilizer.l] Update loadPattern sample because add-optional-data-from-rs-list is included in dump-seq-pattern-file (#959 <https://github.com/start-jsk/rtmros_common/issues/959>)
  * Contributors: Ryo Koyama, Kei Okada, Noriaki Takasugi, Ryo Terasawa, Shunichi Nozawa, Yohei Kakiuchi, Yoshimaru Tanaka, Iori Kumagai, Iori Yanokura, Juntaro Tamura

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 11 Feb 2017 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.3.2-1stretch) stretch; urgency=high

  * [fix] getFootStepParam interface according to upstream change. Remove rleg_coords and lleg_coords.
  * [fix] HrpsysSeqStateROSBridgeImpl.cpp: sensor->localR is world coords
  * [fix] Modified HrpsysSeqStateROSBridgeImpl to enable virtual force
  * [fix] [rtm-ros-robot-interface.l] add time constant prameter according to upstream idl update
  * [fix] [hrpsys_ros_bridge] Fix genjava problem by adding message_generation as build_depend
  * [fix] getFootStepParam interface according to upstream change. Remove rleg_coords and lleg_coords.
  * [fix] [hrpsys_ros_bridge]change D if D from hrpsys is empty
  * [feat] [hrpsys_ros_bridge/test/test-samplerobot.py] add test programs to check frame_id of off_xxsensor and ref_xxsensor (#940)
  * [feat] Set /robot/type param according to lower-case robot name such as samplerobot.
  * [feat] [hrpsys_ros_bridge/test/test-samplerobot.*] add a test program for init of hcf
  * [feat] fix collision visualization, color of sphere will be purple if collision occur
  * [feat] .travis.yml : add test when old hrpsys-ros-bridge exists (#929)
  * [feat] [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add check for param existence for def-set-get-param-method to neglect idl mismatch error. Fix indent. (#933)
  * [feat] [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add reference force updater euslisp methods.
  * [feat] [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add object turnaround detector moment version interface.l
  * [feat] Add define controller #887 <https://github.com/start-jsk/rtmros_common/issues/887>
  * [feat] Add leg limb controller setting.
  * [feat] Add method to define joint trajectory controller by default setting.
  * [feat] Add gopos overwrite and graspless manip mode to all demos
  * [feat] Add example for graspless manip mode and gopos overwrite.
  * [feat] Add euslisp interface for graspless manip mode.
  * [feat] add a set-default-step-time-with-the-same-swing-time method
  * [feat] add time constant prameter according to upstream idl update
  * [feat] Add HrpsysSeqStateROSBridge tf rate test
  * [feat] enable virtual force in HrpsysSeqStateROSBridgeImpl
  * [feat] Enable to set subscription_type for DataPorts from hrpsys_ros_bridge.launch argument. Use new by default to keep backward compatibility.
  * [feat] Add loading of optionalData from seq pattern file.
  * [improve] add more mesage to prevent confusion
  * [improve] Add setting for ReferenceForceUpdater
  * [improve] Reset object turnaround detector's detector total wrench mode as TOTAL_FORCE in force estimation.
  * [improve] Enable to set push_policy and push_rate for DataPorts from hrpsys_ros_bridge.launch argument. Use all and 50.0 by default to keep backward compatibility.
  * [improve] Rename tf extract script for test and add comments for that
  * [improve] add arguments(SIMULATOR_NAME_[ANGLE,VELOCITY,TORQUE]) to hrpsys_ros_bridge.launch, for connecting rtc components other than RobotHardware
  * [improve] add time constant prameter according to u… #910 <https://github.com/start-jsk/rtmros_common/issues/910>
  * [improve] add argument to set periodic time for object turning detection.
  * [improve] define method to set/get emergency-stopper-paramMerge pull request #865 <https://github.com/start-jsk/rtmros_common/issues/865>
  * [improve] Suppress /tf publishing rate by tf_rate using Timer callback in ros.
  * [improve] Separate updating odometry and imu into functions
  * [improve] Update st param #894 <https://github.com/start-jsk/rtmros_common/issues/894>
  * [improve] add eefm_swing_rot_spring_gain / eefm_swing_pos_spring_gain as st param
  * [improve] Update joint group and add test for limb controller
  * [doc] [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] In-code documentation improvement
  * [doc] [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Set default documentation string for def-set-get-param-method setter and getter.
  * [doc] [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add argument documentation for :set-xxx methods.
  * [doc] [hrpsys_ros_bridge/euslisp/README.md,hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Update readme and euslisp documentation strings
  * [doc] default documentation string for def-set-get-param-method setter and getter.
  * [doc] In-code documentation improvement
  * Contributors: Eisoku Kuroiwa, Kei Okada, Kentaro Wada, Masaki Murooka, Shunichi Nozawa, Yohei Kakiuchi, Yu Ohara, Iori Yanokura

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Mon, 25 Apr 2016 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.3.1-1stretch) stretch; urgency=high

  * deb release only targeting to indigo
  * Fix for travis testing
    
      * [hrpsys_ros_bridge/test/test-samplerobot.test] Use joint_states instead of odom to check tf because joint_states is more related with tf and [Hz] printing. than odom #880 <https://github.com/start-jsk/rtmros_common/pull/880>
      * [hrpsys_ros_bridge/test/test-samplerobot.test] Increase hzerror according to https://github.com/start-jsk/rtmros_common/issues/877#issuecomment-164669534. Current worst travis hz seem to be more than 300[Hz], so set 200[Hz] error. #879 <https://github.com/start-jsk/rtmros_common/pull/879>
      * catkin.cmake: use ccache only for CI environment #872 <https://github.com/start-jsk/rtmros_common/pull/872>
      * add depends from AutoBalancerService.hh to StabilizerService.hh #872 <https://github.com/start-jsk/rtmros_common/pull/872>
      * [hrpsys_ros_bridge/test/hrpsys-samples/test_samplerobot_euslisp_unittests.launch] Increase time-limit for autobalancer euslisp test #879 <https://github.com/start-jsk/rtmros_common/pull/879>
    
  * Fasten script excution
    
      * [hrpsys_ros_bridge/scripts/sensor_ros_bridge_connect.py] Reduce unnecessary waiting for sensor port rosbridge connection. #879 <https://github.com/start-jsk/rtmros_common/pull/879>
    
  * Bug fix
    
      * [hrpsys_ros_bridge/src/HrpsysSeqStateROSBridge.cpp] Initialize prev_odom_acquired flag. #879 <https://github.com/start-jsk/rtmros_common/pull/879>
    
  * Add euslisp new example and update for example conf setting
    
      * [hrpsys_ros_bridge/test/hrpsys-samples/samplerobot-stabilizer.l] Add Stabilizer + loadPattern example for euslisp interface. #875 <https://github.com/start-jsk/rtmros_common/pull/875>
      * [hrpsys_ros_bridge/catkin.cmake] Add Sequencer's optionalData setting for sample conf files. #875 <https://github.com/start-jsk/rtmros_common/pull/875>
    
  * Contributors: Kei Okada, Shunichi Nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 15 Dec 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.3.0-1stretch) stretch; urgency=high

  * deb release only targeting to indigo
  * [.travis.yml, hrpsys_ros_bridge/catkin.cmake] Enable travis euslisp test using USE_DEB=source and reducing make jobs and loads #806 <https://github.com/start-jsk/rtmros_common/issues/806>
  * Bug Fixes
    
      * [hrpsys_ros_bridge/euslisp/datalogger-log-parser.l] modify string conversion in RobotHardware0 (for robot name containing '_') #848 <https://github.com/start-jsk/rtmros_common/issues/848>
      * [hrpsys_ros_bridge/euslisp/datalogger-log-parser.l] Add RobotHardware0_servoState data to robot state #853 <https://github.com/start-jsk/rtmros_common/issues/853>
      * [hrpsys_ros_bridge/euslisp/datalogger-log-parser.l] Update unitsysetm conversion of angle-vector (rad->deg, m->mm) #845 <https://github.com/start-jsk/rtmros_common/issues/845>
      * [hrpsys_ros_bridge/catkin.cmake] Fix typo for hrpsys_PREFIX #843 <https://github.com/start-jsk/rtmros_common/issues/843>
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Return detection mode. #841 <https://github.com/start-jsk/rtmros_common/issues/841>
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Update set force method. Add reset force. #840 <https://github.com/start-jsk/rtmros_common/issues/840>
      * [hrpsys_ros_bridge/catkin.cmake] Update PDgain conf property name #816 <https://github.com/start-jsk/rtmros_common/issues/816>
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Fix for pos and rot ik thre #803 <https://github.com/start-jsk/rtmros_common/issues/803>
      * [cmake/compile_robot_model.cmake] move location of set variable (compile_all_target) #779 <https://github.com/start-jsk/rtmros_common/issues/779>
      * [src/hrpsys_ros_bridge/hrpsys_dashboard.py] Run event loop for 1 sec after showing splashwindow to force to load image immediately #762 <https://github.com/start-jsk/rtmros_common/issues/762>
      * [euslisp/datalogger-log-parser.l] Warn message if wrong path is specified #767 <https://github.com/start-jsk/rtmros_common/issues/767>
      * [euslisp/datalogger-log-parser.l]  Add limb-list first, Add st and abc properties to datalogger log parser #761 <https://github.com/start-jsk/rtmros_common/issues/761>
    
  * /off_xxsensor and /xxsensor
    
      * [hrpsys_ros_bridge/src/HrpsysSeqStateROSBridge.cpp] fix  /off_xxsensor frame_id #867 <https://github.com/start-jsk/rtmros_common/issues/867>
      * [hrpsys_ros_bridge/src/HrpsysSeqStateROSBridge.cpp] fix frame_id of off_xxsensor #855 <https://github.com/start-jsk/rtmros_common/issues/855>
    
  * euslisp/rtm-ros-robot-interface.l : add/modify interfaces for new/updated rtc
    
      * [hrpsys_ros_bridge/test/hrpsys-samples/samplerobot-auto-balancer.l] Use 4limbs in startAutoBalancer when Groups has rarm and larm and  update sample. #866 <https://github.com/start-jsk/rtmros_common/issues/866>
      * add reference remaining_time in /ref_contact_states #857 <https://github.com/start-jsk/rtmros_common/issues/857>
      * Add method of servo-state #853 <https://github.com/start-jsk/rtmros_common/issues/853>
      * Add calc velocity from velocity offset #842 <https://github.com/start-jsk/rtmros_common/issues/842>
      * Add euslisp style argument for leg_default_translate_pos #836 <https://github.com/start-jsk/rtmros_common/issues/836>
      * Add grasp controller interface methods.l #831 <https://github.com/start-jsk/rtmros_common/issues/831>
      * Enable to set optional-data from robot and contact-state #831 <https://github.com/start-jsk/rtmros_common/issues/831>
      * Add optionalData from euslisp rs-list #822 <https://github.com/start-jsk/rtmros_common/issues/822>
      * add stabilizer-end-coords-list #820 <https://github.com/start-jsk/rtmros_common/issues/820>
      * Update setter methods #818 <https://github.com/start-jsk/rtmros_common/issues/818>
      * Add ":set-foot-steps-with-param-and-base-height" method in order to specify footstep with params and base height #811 <https://github.com/start-jsk/rtmros_common/issues/811>
      * update default-zmp-offsets interface according to hrpsys-base change #808 <https://github.com/start-jsk/rtmros_common/issues/808>
      * add an interface for multi legs footsteps #795 <https://github.com/start-jsk/rtmros_common/issues/795>
      * get ref-capture-point from Stabilizer rtco #794 <https://github.com/start-jsk/rtmros_common/issues/794>
      * update AutoBalancerParam according to https://github.com/fkanehiro/hrpsys-base/pull/750 #786 <https://github.com/start-jsk/rtmros_common/issues/786>
      * get cp from Stabilizer rtc #781 <https://github.com/start-jsk/rtmros_common/issues/781>
      * Update footstep methods to enable overwriting #775 <https://github.com/start-jsk/rtmros_common/issues/775>
      * get emergency-mode from robot-interface #772 <https://github.com/start-jsk/rtmros_common/issues/772>
      * Add calculation of sole edge #759 <https://github.com/start-jsk/rtmros_common/issues/759>
    
  * Add PointCloudROSBridge and RangeSensorROSBridge, and modify ImageSensorROSBridge #785 <https://github.com/start-jsk/rtmros_common/issues/785>
    
      * [src/RangeSensorROSBridge.cpp] add intensity parameter for adding intensities #802 <https://github.com/start-jsk/rtmros_common/issues/802>
      * [src/ImageSensorROSBridge.cpp] fix parsing camera parameter #798 <https://github.com/start-jsk/rtmros_common/issues/798>
      * [src/ImageSensorROSBridge.cpp] fix bug / reset debug counter #797 <https://github.com/start-jsk/rtmros_common/issues/797>
      * [hrpsys_ros_bridge/cmake/compile_robot_model.cmake] Use collada_urdf_jsk_patch in order to convert dae into urdf which can be used in gazebo #793 <https://github.com/start-jsk/rtmros_common/issues/793>
      * [src/ImageSensorROSBridge.cpp] add camera param setter by ros parameter #791 <https://github.com/start-jsk/rtmros_common/issues/791>
      * [src/PointCloudROSBridge.cpp] fix PointCloudROSBridge, color and frame #790 <https://github.com/start-jsk/rtmros_common/issues/790>
      * [src/RangeSensorROSBridge.cpp] fix RangeSensorROSBridge / time_increment is zero #788 <https://github.com/start-jsk/rtmros_common/issues/788>
      * [src/RangeSensorROSBridge.cpp] fix frame of RangeSensor #789 <https://github.com/start-jsk/rtmros_common/issues/789>
    
  * Add rsvel port (#807 <https://github.com/start-jsk/rtmros_common/issues/807>)
    
      * [src/HrpsysSeqStateROSBridge.cpp, launch/hrpsys_ros_bridge.launch] add rsvel port to HrpSeqStateROSBridge read dq in order to add velocity values to joint_states
      * [hrpsys_ros_bridge/launch/hrpsys_ros_bridge.launch] add USE_VELOCITY_OUTPUT to arguments of rtmlaunch #821 <https://github.com/start-jsk/rtmros_common/issues/821>
    
  * Add ObjectTurnaroundDetector methods #838 <https://github.com/start-jsk/rtmros_common/issues/838>
    
      * [src/hrpsys_ros_bridge/samplerobot_hrpsys_config.py] Update latest st parameter for torque control
      * [euslisp/rtm-ros-robot-interface.l] Add set-ref-force time #838 <https://github.com/start-jsk/rtmros_common/issues/838>
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add ObjectTurnaroundDetector methods
      * [test/hrpsys-samples/samplerobot-carry-object.l] Add carry object euslisp sample #838 <https://github.com/start-jsk/rtmros_common/issues/838>
    
  * SLAM support
    
      * [hrpsys_ros_bridge/src/hrpsys_ros_bridge/hrpsys_dashboard.py] Add MapButton for SLAM and odometry #869 <https://github.com/start-jsk/rtmros_common/issues/869>
      * [src/HrpsysSeqStateROSBridge.cpp] Transform twist from local to global in pose covarance calculation because pose is in global #830 <https://github.com/start-jsk/rtmros_common/issues/830>
      * [src/HrpsysSeqStateROSBridge.cpp] Set root_link as child_frame_id and describe twist in child_frame_id coordinate #828 <https://github.com/start-jsk/rtmros_common/issues/828>
      * [src/HrpsysSeqStateROSBridge.cpp] Fix covariance calculation in HrpsysSeqStateROSBridge: previous verision calculation only can be applied in nonhoronomic robot #812 <https://github.com/start-jsk/rtmros_common/issues/812>
      * [src/HrpsysSeqStateROSBridge.cpp] Fix coordinate representation: omega in twist is global
      * [src/HrpsysSeqStateROSBridge.cpp] Calculate covariance of odometry in HrpsysSeqStateROSBridge
      * [src/HrpsysSeqStateROSBridge.cpp] update prev_odom only when odom is successfully updated in dt > 0
      * [src/HrpsysSeqStateROSBridge.cpp] Calculate angular twist
    
  * Special joint support #837 <https://github.com/start-jsk/rtmros_common/issues/837>
    
      * [models/samplespecialjointrobot.yaml, catkin.cmake] Add cmake setting and euscollada yaml for special joint robot
    
  * add ContactState.msg, ContactStateStamped.msg, ContactStatesStamped.msg #834 <https://github.com/start-jsk/rtmros_common/issues/834>
    
      * [msg/ContactState.msg] Add frame_id to contact states messages
      * [launch/hrpsys_ros_bridge.launch, src/HrpsysSeqStateROSBridge{,cpp,.h,Impl.cpp,Impl.h}] separate ContactStates.msg into ContactState.msg, ContactStateStamped.msg and ContactStatesStamped.msg
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add euslisp interface to get contact states
      * [hrpsys_ros_bridge/src/HrpsysSeqStateROSBridge.cpp] add contact states publisher of AutoBalancer and Stabilizer
      * [msg/ContactState.msg] add ContactStates.msg for legged robots
    
  * Sample codes
    
      * [src/hrpsys_ros_bridge/sample4legrobot_hrpsys_config.py, src/hrpsys_ros_bridge/sample4legrobot_hrpsys_config.py] set ThermoLimiter parameters to decrease debug messages #849 <https://github.com/start-jsk/rtmros_common/issues/849>
      * [src/hrpsys_ros_bridge/sample4legrobot_hrpsys_config.py] update sample4legrobot st and abc parameters, set st and abc parameters #847 <https://github.com/start-jsk/rtmros_common/issues/847>
      * [hrpsys_ros_bridge/src/hrpsys_ros_bridge/samplerobot_hrpsys_config.py] Update st vertices setting #819 <https://github.com/start-jsk/rtmros_common/issues/819>
      * [src/hrpsys_ros_bridge/sample4legrobot_hrpsys_config.py,  models/sample4legrobot.yaml, euslisp/sample4legrobot-interface.l,  catkin.cmake] Add sample4legrobot generation if exists #817 <https://github.com/start-jsk/rtmros_common/issues/817>
      * [euslisp/sample4legrobot-interface.l] Update path hrpsys_ros_bridge_tutorials -> hrpsys_ros_bridge #817 <https://github.com/start-jsk/rtmros_common/issues/817>
      * [catkin.cmake] Add check for sample_4leg_robot existence #817 <https://github.com/start-jsk/rtmros_common/issues/817>
      * [hrpsys_ros_bridge/src/hrpsys_ros_bridge/samplerobot_hrpsys_config.py] Update st damping parameters #809 <https://github.com/start-jsk/rtmros_common/issues/809>
      * [hrpsys_ros_bridge/catkin.cmake, src/hrpsys_ros_bridge/samplerobot_hrpsys_config.py, test/hrpsys-samples/test_samplerobot_euslisp_unittests.launch]  Enable euslisp unittest for unstable rtcs #806 <https://github.com/start-jsk/rtmros_common/issues/806>
      * [scripts/default*.launch.in,,cmake/compile_robot_model.cmake] Use arguments to specify whether unstable or not #806 <https://github.com/start-jsk/rtmros_common/issues/806>
      * [hrpsys_ros_bridge/test/hrpsys-samples/samplerobot-unittest.l, samplerobot-auto-balancer.l] Update auto-balancer test functions and update unittest order #806 <https://github.com/start-jsk/rtmros_common/issues/806>
      * [hrpsys_ros_bridge/test/hrpsys-samples/test_samplerobot_euslisp_unittests.launch] Add collision detector test #805 <https://github.com/start-jsk/rtmros_common/issues/805>
    
  * Move euslisp sample code from roseus_tutorials #800 <https://github.com/start-jsk/rtmros_common/issues/800>
    
      * [hrpsys_ros_bridge/test/hrpsys-samples/test_samplerobot_euslisp_unittests.launch] Add rostest launch file for euslisp unittest and use .launch instead of .test.
      * [hrpsys_ros_bridge/test/hrpsys-samples, hrpsys_ros_bridge/euslisp/samplerobot-interface.l] Fix package name for sample robot euslisp files (hrpsys_ros_bridge_tutorials -> hrpsys_ros_bridge)
    
  * Use emergency stopper by default for unstable rtc robots  #760 <https://github.com/start-jsk/rtmros_common/issues/760>
    
      * [hrpsys_ros_bridge/cmake/compile_robot_model.cmake] Use emergency stopper by default for unstable rtc robots
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Add method for emergency stop methods
      * [hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l] Enable to set rosbridge name for idl srv methods.
      * [hrpsys_ros_bridge/launch/hrpsys_ros_bridge.launch] Add emergency stopper ROSBridges
      * [scripts/diagnostics.py] publish diagnostic of emergency_mode from diagnostics.py #780 <https://github.com/start-jsk/rtmros_common/issues/780>
      * [src/HrpsysSeqStateROSBridge{,cpp,.h,Impl.cpp,Impl.h}] publish emergency_mode from EmergencyStopper rtc #763 <https://github.com/start-jsk/rtmros_common/issues/763>
    
  * Contributors: Eisoku Kuroiwa, Kei Okada, Masaki Murooka, Ryohei Ueda, Shunichi Nozawa, Tatsuya Ishikawa, Yohei Kakiuchi, Yuta Kojio, Iori Kumagai

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 08 Dec 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.14-1stretch) stretch; urgency=high

  * [hrpsys_ros_bridge] Add splash screen to hrpsys dashboard
  * Enable to set step time for each foot steps and update documentation
  * Add emergency walking stop and update documentations
  * [hrpsys_ros_bridge] set position of imu_floor zero
  * Add method to get remaining foot steps and displaying method
  * [cmake_compile_robot_model.cmake] get_filename_component DIRECTORY is only available > cmake 2.8.12
  * Publish cop position in end link frame
  * Publish COP for each end effectors. COPInfo is provided by Stabilizer.
  * Add --use-robot-hrpsys-config argument to compile robot old (added to compile robot in 54e64bf3c4131fc907c6b7c0a34d728f82948e76)
  * Contributors: Kei Okada, Ryohei Ueda, Shunichi Nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Mon, 22 Jun 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.13-1stretch) stretch; urgency=high

  * [launch/hrpsys_ros_bridge.launch] Add USE_ROBOT_POSE_EKF
  * [euslisp/rtm-ros-robot-interface.l] fix typo
  * [euslisp/rtm-ros-robot-interface.l] Add :adjust-foot-steps-roll-pitch to reset current foot steps
  * [euslisp/rtm-ros-robot-interface.l] Add toe heel angle for :set-foot-steps-with-param-no-wait
  * [euslisp/rtm-ros-robot-interface.l] Add argument for transition times
  * [euslisp/rtm-ros-robot-interface.l] Use current foot midcoords of rleg and lleg in roll pitch method
  * [euslisp/rtm-ros-robot-interface.l] Add adjust footsteps euslisp interface
  * [euslisp/datalogger-log-parser.l] Add function to dump seq pattern file from datalogger log
  * [euslisp/rtm-ros-robot-interface.l,uslisp/rtm-ros-robot-interface.l] Add force moment param zerosettin method and use it in calib program
  * [euslisp/rtm-ros-robot-interface.l] raise error when bridged service call failed
  * [euslisp/rtm-ros-robot-interface.l] Make interpolation-time in sync-controller shorter
  * [euslisp/rtm-ros-robot-interface.l] Add :set-foot-steps-with-base-height
  * [euslisp/rtm-ros-robot-interface.l] Fix typo in start method. Start auto balancer by legs.
  * [euslisp/rtm-ros-robot-interface.l] Add euslisp methods for default unstable controllers
  * [src/HrpsysSeqStateROSBridge.cpp] imu_floor again
  * [src/hrpsys_ros_bridge/hrpsys_dashboard.py] add st/abc/ic start at once button
  * [hrpsys_ros_bridge/cmake/compile_robot_model.cmake] Enable to specify robot specific hrpsys_config.py
  * [launch/hrpsys_ros_bridge.launch] Add argument to specify periodic rate of seq ros bridge
  * [euslisp/rtm-ros-robot-interface.l] add hours, minutes and seconds for :save-log
  * [.travis.yaml, hrpsys_ros_bridge/catkin.cmake] add eusdoc
  * [euslisp/rtm-ros-robot-interface.l] Support t or nil in setter arguments
  * Contributors: Eisoku Kuroiwa, Kei Okada, Ryohei Ueda, Shunichi Nozawa, Yohei Kakiuchi, Iori Kumagai

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Wed, 10 Jun 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.12-1stretch) stretch; urgency=high

  * [euslisp/rtm-ros-robot-interface.l] Update function to calculate toe heel offset. Support both pos and zmp and add documentation
  * [hrpsys_ros_bridge/cmake/compile_robot_model.cmake] fix for --conf option with comment
  * Contributors: Kei Okada, Shunichi Nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 26 Apr 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.11-1stretch) stretch; urgency=high

  * [catkin.cmake] add depend to pr2_controllers_msgs in catpkin_package
  * [cmake/compile_robot_model.cmake] fix dependency add_custom_depend need to DEPEND to other target
  * [euslisp/rtm-ros-robot-interface.l] Add calculate-toe-heel-pos-offsets and set-foot-steps-with-param
  * Contributors: Kei Okada, Shunichi Nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 24 Apr 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.10-1stretch) stretch; urgency=high

  * add rewrited version of compile_robot_model.cmake
    
      * [compile_robot_model.cmake] generate controller_config even if yaml is not found
      * [compile_robot_model.cmake] use add_custom_target/command for eusif and launch, set PROJECT_PKG_NAME
      * [compile_robot_model.cmake] rewrite everything from scratch
    
  * euslisp
    
      * [rtm-ros-robot-interface.l] Add method to align footsteps    with roll or pitch angle
      * [datalogger-log-parser.l] change max-line count method
      * [rtm-ros-robot-interface.l] Add sync-controller method, which preserve limb-controller angle before remove-joint-group is called.
      * [rtm-ros-robot-interface.l] Enable to set gravitational acceleration for calculating st parameter
    
  * [HrpsysSeqStateROSBridgeImpl.{cpp,h}] display more debug info for diagnostics
  * [cmake/compile_robot_model.cmake] Revert "compile_robot contains output files, not targets"
  * [hrpsys_ros_bridge/package.xml] Limits dependent pkg version to avoid critical error in downstream (tork-a/rtmros_nextage/#160)
  * Contributors: Eisoku Kuroiwa, Isaac IY Saito, Kei Okada, Shunichi Nozawa, Iori Kumagai

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 23 Apr 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.9-1stretch) stretch; urgency=high

  * [package.xml] remove pr2_controllers, add pr2_controller_msgs, pr2_msgs, control_msgs package.xml
  * [collision_state] fix to work collision state
    
      * [collision_state.py] fix minor bug of collision_state.py CORBA.OBJECT_NOT_EXIST -> omniORB.CORBA.OBJECT_NOT_EXIST
      * [collision_state.py] check isActive() to avoid raise error during servo on phase
    
  * [hrpsys_ros_bridge/catkin.cmake]
    
      * move rtmlaunch/rtmtest from hrpsys_ros_bridge to openrtm_tools, add envhook for catkin users
    
  * [hrpsys_tools/hrpsys.launch] support DEBUG_HRPSYS argument to run rtcd with gdb
  * [hrpsys_ros_bridge/cmake/compile_robot_model.cmake]
    
      * Add dependency from the files generated by  export_collada to compile_robots in order to prevent parallel execution  of export_collada
      * Check current if scope has parent scope when set  variable in PARENT_SCOPE in compile_robot_model.cmake to supress warning messages
      * Fix serious typo: daefile -> _daefile in compile_robot_model.cmake
      * fix warning in if/endif macro
      * compile_robtos should be list of all generated lisp file, not targets
    
  * [euslisp/rtm-ros-robotics-interface.l]
    
      * Add impedance controller mode getter method
      * Return Euslisp coordinates from :get-foot-step-param
      * Add methods to get Euslisp style parameters from IDL enum type
      * Add comments for st methods
      * Add methods to tune st parameter
      * Add functions to calculate eefm st parameters
      * Fix order of ee setting
      * Pass arguments for joint-properties to ProjectGenerator
    
  * Contributors: JAXON, Kei Okada, Ryohei Ueda, Shunichi Nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 10 Apr 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.8-1stretch) stretch; urgency=high

  * [hrpsys_ros_bridge] Do not run collada_to_urdf parallel. In order to
    avoid parallel execution of collada_to_urdf, add tricky dependency
  * Add graspless manip mode euslisp interface
  * [test-*.py] test name could not contain minus? any changet to underscore (http://answers.ros.org/question/197377/rostest-not-finding-the-actual-test/)
  * [test-samplerobot.py] fix syntax error on loadPattern
  * update for legged robot
  * Sample.pos is not installed via deb package, see https://github.com/fkanehiro/openhrp3/issues/46
  * Fix rmfo sensor argument
  * copy rtmlaunch,rtmtest to global_bin when compile
  * Add method to calculate go-velocity param from velocity center offset
  * Add menus for unstable rtcs (not used by default)
  * Add setting for HrpsysConfigurator in hrpsys dashboard and apply it to servoOn/Off menu (disabled by default).
  * Remove unused initial leg offsetting because this is implemented AutoBalancer's setFootSteps
  * [hrpsys_ros_bridge] Refactor compile_robot_model.cmake
  * Use ee name for impedance methods
  * [hrpsys_ros_bridge] collision_state.py:  need to wait for activate
  * [hrpsys_ros_bridge] sensor_ros_bridge_connect.py: wait for sh, sometimes we can not find them
  * Update impedance start/stop methods
  * [hrpsys_ros_bridge] Do not call export_collada in parallel
  * Update :reset-force-moment-offset funcs and add documents
  * Update documentation strings for ImpedanceController and Ref forces
  * [hrpsys_ros_bridge] Fix path for catkin build
  * pass :rarm instead of 'rhsensor' or 'rasensor' to :set-forcemoment-offset-param
  * Add seq base pos and rpy methods
  * Remove duplicated method and fix argument passing for imp methods
  * Contributors: Kei Okada, Ryohei Ueda, Shunichi Nozawa, Eisoku Kuroiwa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 08 Mar 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.7-1stretch) stretch; urgency=high

  * Add :reference-root-coords method for log
  * Update datalogger parser time parsing and robothardware naming
  * Add euslisp methods for seq wait interpolation and co get status
  * Enable virtual force setting. Read conf file in HrpsysSeqStateROSBridge and connect vfs ports if exists
  * Add set ref force and moment methods. Enable vforcesensors
  * change robot-init function to pass arguments to initializer
  * Set default name as co
  * Use segment name of body_info as collision detection frame_id
  * Add argument to select collision_state.py activation because collision_state.py can be launched in hrpsys_ros_bridge.launch
  * Enable to configure collision detector instance name
  * Use subscription_type as new to avoid influence on realtime process
  * (rtm-ros-robot-interface) : Add optionaldata for dump-seq-pattern-file
  * (rtm-ros-robot-interface) : Add function to load seq pattern file and euslisp list from it.
  * (rtm-ros-robot-interface) : Add documentation string for dump-seq-pattern-file
  * Fix frame of loadPattern
  * Add euslisp interface method for reference wrench
  * Publish reference wrench from StateHolder wrench data ports. Check existence of wrench ports because hrpsys-base 315.1.9 does not have wrench ports in Seq and Sh.
  * Add RMFO calib readme
  * Update RMFO calibration sequence. Use parameter file
  * Add load and dump rmfo param methods
  * Separate robot date string as method and fix :save-log default argument
  * on indigo, hrpsys is not ros-catkin package
  * fix for new packaging openrtm/hrpsys (compile package directoly from original repository)
  * Fix typo of hrpsys_ros_bridge.launch
  * Add USE_HRPSYS_PROFILE to toggle whether running hrpsys_profile
  * Add parameter ~publish_sensor_tf to HrpsysSeqStateROSBridge to toggle
    publishing tf frames of the sensors
  * Fix unitsystem for documentation
  * Add directory to generate Euslisp documentation
  * Enable to set integer enum values
  * (rtm-ros-robot-interface) : Fix typo in save-log
  * (rtm-ros-robot-interface) : Add date string and robot name to Datalogger log name by default.
  * (rtm-ros-robot-interface) : Update seq methods. Revise set-interpolation-mode using defconst param and remove deprecated dump-seq parttern
  * Merge remote-tracking branch 'origin/master' into tmp_update_impedance_controller_methods
  * (rtm-ros-robot-interface) : Update impedance controller setter and getter
  * (rtm-ros-robot-interface) : Remove deprecated euslisp interface and functions.
  * Update rtmbuild_init to specify dependency of generate_messages and
    add new service interface to HrpsysSeqStateROSBridge to specify transformation
    for each sensor
  * Merge pull request #583 from eisoku9618/update-print-end-effector-parameter-conf-from-robot
    Merged.
  * do not print a leading colon of :rarm
  * (rtm-ros-robot-interface) : Enable to set st algorithm as Euslisp symbol.
  * remove unnecessary white spaces
  * rename total time of 1 cycle from RobotHardware0 to Summary
  * add eps_of_rh variable in order to reduce unnecessary for loop
  * (test-samplerobot) : Import all srv files in test-samplerobot.py discussed in https://github.com/start-jsk/rtmros_common/issues/558
  * (default_robot*.launch.in) : Add argument for precreate controller
  * (rtm-ros-robot-interface) : Update :set-gait-generator-param method to use defconstant enum values and add printing method
  * (datalogger-log-parser) : Add abc baseTform reading
  * Contributors: Kei Okada, Ryohei Ueda, Shunichi Nozawa, Yohei Kakiuchi, Eisoku Kuroiwa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Mon, 05 Jan 2015 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.6-1stretch) stretch; urgency=high

  * set time-limit to 300
  * (test-samplerobot.py) fix test case, since /clock is sync with hrpsys time, so we can use more strict settings
  * fix test code for changing 0.002
  * (rtm-ros-robot-interface) : Add documentation strings for state methods and rearrange it. Add logger documentation.
  * Contributors: Kei Okada, Shunichi Nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 09 Oct 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.5-1stretch) stretch; urgency=high

  * Improvement on rtm-ros-robot-interface, datalogger-log-parser, samplerobot
  * Fix stamp of odom and imu
  * Improve dependency: robot_pose_ekf.launch, robot_pose_ekf
  * Contributors: Kei Okada, Shunichi Nozawa, YoheiKakiuchi

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Fri, 03 Oct 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.4-1stretch) stretch; urgency=high

  * (test/test-pa10.test) support GUI argument
  * (test/test-pa10.py)   add test for /command
  * (hrpsys_ros_bridge/src/HrpsysJointTrajectoryBridge.cpp) support <controller>/command, see #537
  * (README.md) fix document, based on snozawa's comment
  * Contributors: Kei Okada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 07 Sep 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.3-1stretch) stretch; urgency=high



 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 02 Sep 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.2-1stretch) stretch; urgency=high

  * (rtm-ros-robot-interface)
    
      * Define Euslisp setter and getter from param slots names
      * Update set-st-param for Stabilizer
      * Add KalmanFilter ROS Bridge and euslisp interface to hrpsys_ros_bridge.launch
      * Add calibrate-inertia-sensor
      * Add new arguments for new st param
      * Fix end-effector name (without colon) according to https://github.com/fkanehiro/hrpsys-base/pull/301
      * Update abc and st euslisp interface according to idl update, fkanehiro/hrpsys-base#239 <https://github.com/fkanehiro/hrpsys-base/issues/239>
      * Access robot-state's imu in callback to fix https://github.com/start-jsk/rtmros_tutorials/issues/67
    
  * Use catkin_make -C to change direcotry (Fix #523 <https://github.com/start-jsk/rtmros_common/issues/523>)
  * (datalogger-log-parser.l)
    
      * Support https://github.com/jsk-ros-pkg/jsk_pr2eus/commit/3200b63dfcbd3c02b919fe6ad03c425e5057ee5c commit
      * Support both reference worldcoords and actual worldcoords ;; StateHolder's value is reference and kf is actual.
    
  * added make-default-ForceCalibPosesForLegs to euslisp/calib-force-sensor-params.l
  * (Force sensor)
    
      * fixed accessing to force sensor in calibration function
      * fix AbsoluteForceSensorService -> RemoveForceSensorLinkOffsetService
    
  * (compile_robot_model.cmake, hrpsys.launch, hrpsys_tools_config.py) Add argument to use Unstable RTC List and configure it from cmake discussed in https://github.com/start-jsk/rtmros_gazebo/pull/61
  * Contributors: Kei Okada, Kunio Kojima, Shunichi Nozawa, Masaki Murooka, Isaac IY Saito

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sat, 30 Aug 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.1-1stretch) stretch; urgency=high

  * add euscollada path for compile collada model
  * Merge pull request #495 from k-okada/add_servo_controller
    hrpsys_ros_bridge.launch: add servo controller
  * (datalogger-log-parser.l) : Check existence of zmp value and rpy value
  * hrpsys_ros_bridge.launch: add servo controller fix rtmlaunch options (thanks to @hyaguchijsk)
  * does not use group tag, just use unless tag to disable connection
    between sh.rtc:baseTformOut and baseTform
  * (hrpsys_ros_bridge/package.xml) run_depend on ipython
  * (hrpsys_ros_bridge/package.xml) Sort in alphabetical order
  * (rtm-ros-robot-interface.l, datalogger-log-parser.l) Update imu euslisp methods ;; We should use /imu instead of tf according to https://github.com/start-jsk/rtmros_common/pull/477
  * hrpsys_ros_bridge/euslisp/datalogger-log-parser.l:add reading zmp data from hrpsys log file
  * Merge pull request #458 from snozawa/rotate_camera_z_axis
    Rotate sensor->localR 180[deg] because OpenHRP3 camera -Z axis equals to ROS camera Z axis
  * Merge pull request #477 from garaemon/add-imu-topic-remove-imu-floor
    Add /imu topic and /odom topic remove imu_floor
  * Merge pull request #460 from k-okada/hrpsys_version_gte
    set hrpsys version greater than 315.2.0
  * update pa10 test code
  * publish Imu value to /imu topic and odometory value to /odom.
  * fix ProjectGenerator path for compile_collada_model
  * update .gitignore for auto generated files under hrpsys_ros_bridge directory
  * rtmlaunch; Add usage api doc
  * hrpsys_ros_bridge/euslisp/datalogger-log-parser.l : update state methods and add eof check
  * hrpsys_ros_bridge/README.md, hrpsys_ros_bridge/euslisp/README.md : add README for hrpsys_ros_bridge and euslisp usage
  * hrpsys_ros_bridge/euslisp/datalogger-log-parser.l : support force sensor reading
  * hrpsys_ros_bridge/euslisp/rtm-ros-robot-interface.l : update sensor accessor commited in https://github.com/euslisp/jskeus/pull/92
  * (package.xml files) Update repository URLs
  * (start-jsk/rtmros_common/pull/397) hrpsys_ros_bridge/launch/hrpsys_ros_bridge.launch, hrpsys_ros_bridge/scripts/sensor_ros_bridge_connect.py : rename AbsoluteForceSensor => RemoveForceSensorLinkOffset
  * (collision_detector.launch) add default model file path using one fromreal robot
  * ( https://github.com/start-jsk/rtmros_gazebo/issues/44 ) hrpsys_dashboard.py: add 'import re' for using regular expression
  * add generation of hrpsys_config for robots using unstable RTCs ;; add configuration for unstable RTCs in cmake ;; by default, do not nothing, so there will be no side effect for robots only using Stable RTCs
  * set RTCTREE_NAMESERVERS environment variables, for #453
  * pass args to super class
  * set hrpsys version greater than 315.2.0
  * Rotate sensor->localR 180[deg] because OpenHRP3 camera -Z axis equals to ROS camera Z axis http://www.openrtp.jp/openhrp3/jp/create_model.html
  * add samplerobot.rviz
  * hrpsys_ros_bridge/collision_state.py) Use logerr to highlight an error that could be overlooked
  * (HrpsysJointTrajectoryBridge) ros cpp style macro applied.
  * Contributors: Isaac Desu Saito, Isaac IY Saito, Isaac Isao Saito, Kei Okada, Kunio Kojima, Ryohei Ueda, Tatsushi Karasawa, YoheiKakiuchi, mmurooka, nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 22 Jun 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.2.0-1stretch) stretch; urgency=high

  * bump to 1.2.0for hrpsys 315.2.0

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 13 May 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.0.12-1stretch) stretch; urgency=high

  * (collision_detector.launch) typo
  * use odom instad of imu_floor
  * do not connect port when afs is not found
  * set WALKING and IMPEDANCE controller as non-default RTC
  * update generate config.yaml
  * add both Robot(Robot)0 and RobotHadware0 in datalogger
  * add scripts for auto generating controller config yaml
  * Use subprocess.Popen rather than check_call in order to call
    external process asynchronouslly
  * pass argument to get-ROSBridge-method-defmacro method
  * add generating urdf file to compile_robot_model.cmake
  * Merge pull request #433 from k-okada/do_not_compile_idl_twice
    do not update manifets.xml and copy idl when it is not needed (#429)
  * implement hrpsys_dashboard base on rqt, not on rxtools
  * do not update manifets.xml and copy idl when it is not needed (#429)
  * rename base-pos and base-rpy => root-pos and root-rpy
  * add reading of datalogger properties
  * set REALTIME=ture as default
  * update :start-auto-balancer and :stop-auto-balancer method according to hrpsys-base trunk update at https://code.google.com/p/hrpsys-base/source/detail?r=1039  commit ;; we do not need to change usage of these methods
  * Contributors: Isaac Saito, Kei Okada, Ryohei Ueda, YoheiKakiuchi, Shunichi Nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Mon, 05 May 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.0.11-1stretch) stretch; urgency=high

  * use random staritng  port number for rtm_naming, also try to continue if name server is already running
  * Contributors: Kei Okada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 15 Apr 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.0.10-1stretch) stretch; urgency=high

  * remove sed to comment out pr2_controllers
  * Contributors: Kei Okada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Mon, 14 Apr 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.0.9-1stretch) stretch; urgency=high

  * (hrpsys_ros_bridge) add git to build_depend
  * Contributors: Isaac IY Saito

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 13 Apr 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.0.8-1stretch) stretch; urgency=high

  * use git:// for download pr2_controllers (potential fix for #410 <https://github.com/start-jsk/rtmros_common/issues/410>)
  * add rosdnode to depends(see https://github.com/jsk-ros-pkg/jsk_roseus/pull/65, #411 <https://github.com/start-jsk/rtmros_common/issues/411>)
  * add euscollada_SOURCE_PREFIX and euscollada_PREFIX
  * use start_omninames.sh for rosdevel build environment, see #400 <https://github.com/start-jsk/rtmros_common/issues/400>
  * remove deprecate function to generate conf parameter
  * Added procps, hostname, net-tools build_depends. These tools are used during building and testing
  * Contributors: Kei Okada, Scott K Logan, Shunichi Nozawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 13 Apr 2014 15:00:00 -0000

ros-melodic-hrpsys-ros-bridge (1.0.7-1stretch) stretch; urgency=high

  * call find_package(catkin) fist
  * #22 <https://github.com/start-jsk/rtmros_common/issues/22>: add PROJECT_NAME to the target used in compile_robot_model to avoid collision of the target names
  * add rostest/hrpsys_tools to depends and find_package
  * hrpsys_ros_bridge: (test-compile-robot.launch) add test-compile-robot.launch (but is is not includeded in CMakeLists.txt and use .launch instead of .test due to Issue #87 <https://github.com/start-jsk/rtmros_common/issues/87>), fix compile_robot_model.cmake work with devel of hrpsys_ros_bridge, disable launch script from test-compile-robot.sh
  * hrpsys_ros_bridge: add test-compile-robot.sh test-compile-robot.xml  test-compile-robot.cmake
  * check hrpsys_ros_bridge SOURCE_DIR for both SOURCE_DIR and PREFIX
  * hrpsys_ros_bridge: use catkin package of pr2_controllers_msgs
  * hrpsys_tools, hrpsys_ros_bridge: increase retly to 4 for test
  * hrpsys_ros_bridge: install/lib/python2.7/dist-packages/hrpsys_ros_bridge/__init__.py disappeared somehow? this is  temprarily fix (FIXME)
  * hrpsys_ros_bridge: fix compile_robot_model.cmkae, use find_package to set /lib/openrtm_aist/bin/rtm-naming /lib/openhrp3/export-collada
  * collision_state.py: display with logwarn when CollisionDetector is not found
  * hrpsys_ros_bridge, fix path for installed conf/dae/launch files
  * compile_robot_model.cmake: add debug message in generate_default_launch_eusinterface_files
  * hrpsys_ros_bridge: (test-samplerobot.py, test-p10.py), increase timeout of watForTransform() and catch exception if tf is not found
  * collision_state, wait until co is found, if not found exit with 0, not 1
  * hrpsys_profile.py add Exception
  * hrpsys_ros_bridge: add collada_urdf to depends
  * hrpsys_profile.py: run hrpsys_profile within try block
  * hrpsys_profile.py: remove undefined variables
  * hrpsys_ros_bridge: add visualization_msgs to depeds
  * hrpsys_ros_bridge: fix ProjectGenerator location, see #353
  * hrpsys_ros_bridge: add test code for samplerobot and pa10
  * hrpsys_ros_bridge: add diagnostic_aggregator to depend (manifest.xml package.xml)
  * hrpsys_ros_bridge: add more args to default_robot_*.in (GUI, SIMULATOR_NAME, corbaport)
  * add comment on why we remove depend to pr2_controllers_msgs
  * (package.xml) add angles to build_depend intentinally dut to build_depend to tf does ont install angles
  * (manifest.xml) commented out depend package pr2_controllers_msgs for rosmake dependency graph generation, but comment in for rosmake build objects
  * (manifest.xml) if you have both rosdep and depend, rosmake does not work well, see https://github.com/jsk-ros-pkg/jsk_common/issues/301
  * (manifest.xml) users are expected to manually install ros-groovy-pr2-dashboard
  * (CMakeLists.txt) download pr2_controllers_msgs for groovy/rosbuild
  * fix typo ;; elif -> elseif
  * add
  * Wrong catkin macro (CATKIN-DEPENDS to CATKIN_DEPENDS).
  * change destination of stdout of rtmlaunch.py by OUTPUT arg
  * add CMAKE_PREFIX_PATH so that rosrun hrpsys ProjectGenerator works
  * Merge pull request #334 from k-okada/master
  * add openhrp3_PREFIX, more debug message
  * add / after hrpsys_idl_DIR
  * add hrpsys to find_package
  * add more verbose log when error
  * update PKG_CONFIG_PATH for hrpsys-base
  * display error output
  * add depend to pkg-config
  * add depend to pkg-config
  * added euslisp, srv, idl directories to install
  * move to git repository
  * add hrpsys to find_package
  * add more verbose log when error
  * Merge branch 'master' of http://github.com/k-okada/rtmros_common
  * display error output
  * add depend to pkg-config
  * add depend to pkg-config
  * update PKG_CONFIG_PATH for hrpsys-base
  * Merge branch 'master' into garaemon-master
  * not generating sh but running rostes directory to avoid escape problem
  * Merge branch 'master' of http://github.com/k-okada/rtmros_common
  * use pkg-config to find directories
  * Merge branch 'master' of https://github.com/start-jsk/rtmros_common
  * move to git repository
  * added euslisp, srv, idl directories to install
  * fixing list syntax
  * force to set ROS_PACKAGE_PATH when calling euscollada for catkin build
  * adding LD_LIBRARY_PATH
  * remove depend to robot_monitor
  * changing the working directory when call export-collada
  * do not compile lisp code if euxport collada is not exists
  * add diagnositcs_msgs to fake rosdep
  * add dynamic_recofigure to fake rosdep
  * add several rosdep names to fake rosdep
  * add rosdep hrpsys/openrtm_aist to fake rosdep
  * profibit to run rostest parallel
  * installing src directory as python package
  * (hrpsys_ros_bridge/package.xml) Partially revert r6936 where a dependency was removed by mistake.
  * Contributors: Kei Okada, Ryohei Ueda

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Wed, 19 Mar 2014 15:00:00 -0000


